    processor 6502
    include "vcs.h" 
    include "macro.h" 
    include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 5
customarea2         ds 5
customarea3         ds 5
customarea4         ds 5
customarea5         ds 5
customarea6         ds 5

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output
 
    ASSYMMETRICALJUMPMANKERNEL JUMP_PF1-FOLLOW_TOP, FOLLOW_TOP-JUMP_PF0
CALC1 = (FOLLOW_CUSTOM1-JUMP_PF0)
    CUSTOMPF0PF1PF2JUMPMANKERNEL FOLLOW_TOP-FOLLOW_CUSTOM1, CALC1, JUMP_PF0+CALC1, JUMP_PF1+CALC1, JUMP_PF2+CALC1, JUMP_PF3+CALC1, JUMP_PF4+CALC1, customarea1
    ASSYMMETRICALJUMPMANKERNEL FOLLOW_CUSTOM1-FOLLOW_MIDDLE1, FOLLOW_MIDDLE1-JUMP_PF0
CALC2 = (FOLLOW_CUSTOM2-JUMP_PF0)
    CUSTOMPF0PF1PF2JUMPMANKERNEL FOLLOW_MIDDLE1-FOLLOW_CUSTOM2, CALC2, JUMP_PF0+CALC2, JUMP_PF1+CALC2, JUMP_PF2+CALC2, JUMP_PF3+CALC2, JUMP_PF4+CALC2, customarea2
    ASSYMMETRICALJUMPMANKERNEL FOLLOW_CUSTOM2-FOLLOW_MIDDLE2, FOLLOW_MIDDLE2-JUMP_PF0
CALC3 = (FOLLOW_CUSTOM3-JUMP_PF0)
    CUSTOMPF0PF1PF2JUMPMANKERNEL FOLLOW_MIDDLE2-FOLLOW_CUSTOM3, CALC3, JUMP_PF0+CALC3, customarea4, JUMP_PF2+CALC3, JUMP_PF3+CALC3, JUMP_PF4+CALC3, customarea3
    ASSYMMETRICALJUMPMANKERNEL FOLLOW_CUSTOM3-FOLLOW_MIDDLE3, FOLLOW_MIDDLE3-JUMP_PF0
CALC4 = (FOLLOW_CUSTOM4-JUMP_PF0)
    CUSTOMPF0PF1PF2JUMPMANKERNEL FOLLOW_MIDDLE3-FOLLOW_CUSTOM4, CALC4, customarea5, customarea6, JUMP_PF2+CALC4, JUMP_PF3+CALC4, JUMP_PF4+CALC4, JUMP_PF5+CALC4
    ASSYMMETRICALJUMPMANKERNEL FOLLOW_CUSTOM4-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR BombsInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    BCC FirstZoneFine

    TAY
    LDX 4
Zone1
    LDA customarea1,X
    AND #%00000000
    STA customarea1,X
    DEX
    BPL Zone1
    TYA
    
FirstZoneFine
    LSR
    BCC SecondZoneFine

    TAY
    LDX 4
Zone2
    LDA customarea2,X
    AND #%00000000
    STA customarea2,X
    DEX
    BPL Zone2
    TYA

SecondZoneFine
    LSR
    BCC ThirdZoneFine

    TAY
    LDX 4
Zone3
    LDA customarea3,X
    AND #%00000000
    STA customarea3,X
    DEX
    BPL Zone3
    TYA

ThirdZoneFine
    LSR
    BCC FourthZoneFine

    TAY
    LDX 4
Zone4
    LDA customarea4,X
    AND #%00000000
    STA customarea4,X
    DEX
    BPL Zone4
    TYA

FourthZoneFine
    LSR
    BCC Done

    TAY
    LDX 4
Zone5
    LDA customarea5,X
    AND #%00111111
    STA customarea5,X
    LDA customarea6,X
    AND #%00111111
    STA customarea6,X
    DEX
    BPL Zone5
    TYA

Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

BombsInit
; Init Custom kernel zones    
    LDX 4
InitCustomZones
    LDA JUMP_PF5+FOLLOW_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    LDA JUMP_PF5+FOLLOW_CUSTOM2-JUMP_PF0,X
    STA customarea2,X
    LDA JUMP_PF5+FOLLOW_CUSTOM3-JUMP_PF0,X
    STA customarea3,X
    LDA JUMP_PF1+FOLLOW_CUSTOM3-JUMP_PF0,X
    STA customarea4,X
    LDA JUMP_PF0+FOLLOW_CUSTOM4-JUMP_PF0,X
    STA customarea5,X
    LDA JUMP_PF1+FOLLOW_CUSTOM4-JUMP_PF0,X
    STA customarea6,X
    DEX
    BPL InitCustomZones
    RTS

    ORG $F800

; Data

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
FOLLOW_CUSTOM4
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
FOLLOW_MIDDLE3
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
FOLLOW_CUSTOM3
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
FOLLOW_MIDDLE2
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
FOLLOW_CUSTOM2
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
FOLLOW_MIDDLE1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
FOLLOW_CUSTOM1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %11000000
FOLLOW_TOP
                                .byte   %11100000
                                .byte   %01100000
                                .byte   %00100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000




JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000111
                                .byte   %00000111
                                .byte   %10000111
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %10000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000011
                                .byte   %00000111
                                .byte   %00001110
                                .byte   %00011100
                                .byte   %00111000
                                .byte   %01110000
                                .byte   %11100000
                                .byte   %11000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000001
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %11111100
                                .byte   %11111110
                                .byte   %11111111
                                .byte   %00000011
                                .byte   %00110001
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF3
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000011
                                .byte   %00000111
                                .byte   %11111110
                                .byte   %11111100
                                .byte   %11111000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %01111111
                                .byte   %01111111
                                .byte   %01111111
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FA00

JUMP_PF4
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %11000000
                                .byte   %11100000
                                .byte   %01110000
                                .byte   %00111000
                                .byte   %00011100
                                .byte   %00001110
                                .byte   %00000111
                                .byte   %00000011
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF5
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00100000
                                .byte   %01100000
                                .byte   %11100000
                                .byte   %11000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start