                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 3
customarea2         ds 3
customarea3         ds 3
customarea4         ds 3

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR EasyInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    SYMMETRICALJUMPMANKERNEL JUMP_PF1-LADDER_TOP, LADDER_TOP-JUMP_PF0
    CUSTOMPF2JUMPMANKERNEL LADDER_TOP-LADDER_CUSTOM1, LADDER_CUSTOM1-JUMP_PF0, customarea1, customarea2
    SYMMETRICALJUMPMANKERNEL LADDER_CUSTOM1-LADDER_MIDDLE, LADDER_MIDDLE-JUMP_PF0
    CUSTOMPF2JUMPMANKERNEL LADDER_MIDDLE-LADDER_CUSTOM2, LADDER_CUSTOM2-JUMP_PF0, customarea3, customarea4
    SYMMETRICALJUMPMANKERNEL LADDER_CUSTOM2-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR EasyInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    LSR
    BCC FirstZoneFine

    TAY
    LDX #2
Zone1
    LDA customarea1,X
    AND #%00000001
    STA customarea1,X
    DEX
    BPL Zone1
    TYA

FirstZoneFine
    LSR
    BCC SecondZoneFine
    
    TAY
    LDX #2
Zone2
    LDA customarea2,X
    AND #%00000001
    STA customarea2,X
    DEX
    BPL Zone2
    TYA

SecondZoneFine
    LSR
    BCC ThirdZoneFine

    TAY
    LDX #2
Zone3
    LDA customarea3,X
    AND #%00000001
    STA customarea3,X
    DEX
    BPL Zone3
    TYA

ThirdZoneFine
    LSR
    BCC Done

    TAY
    LDX #2
Zone4
    LDA customarea4,X
    AND #%00000001
    STA customarea4,X
    DEX
    BPL Zone4
    TYA
    
Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

EasyInit
; Init Custom kernel zones    
    LDX 2
InitCustomZones
    LDA JUMP_PF2+LADDER_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    STA customarea2,X
    LDA JUMP_PF2+LADDER_CUSTOM2-JUMP_PF0,X
    STA customarea3,X
    STA customarea4,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
LADDER_CUSTOM2
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
LADDER_MIDDLE
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
LADDER_CUSTOM1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
LADDER_TOP
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00111111
                                .byte   %01111111
                                .byte   %11111111
                                .byte   %11000000
                                .byte   %10001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %11000000
                                .byte   %11100000
                                .byte   %01111111
                                .byte   %00111111
                                .byte   %00011111
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00111111
                                .byte   %01111111
                                .byte   %11111111
                                .byte   %11000000
                                .byte   %10001100
                                .byte   %00000000
                                .byte   %00001100
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %11000000
                                .byte   %11100000
                                .byte   %01110000
                                .byte   %00111000
                                .byte   %00011100
                                .byte   %00001110
                                .byte   %00000111
                                .byte   %00000011
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11000111
                                .byte   %11000111
                                .byte   %11000111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start